// Copyright (c) Microsoft Corporation. 
// Licensed under the MIT license. 

#include <string>
#include <stdlib.h>
#include <filesystem>
#include <future>
#include "SimplygonLoader.h"


void ImportExportOBJ(Simplygon::ISimplygon* sg)
{
	Simplygon::spSceneImporter sgSceneImporter = sg->CreateSceneImporter();
	sgSceneImporter->SetImportFilePath( "../Assets/Chain/Chain.obj" );
	if(!sgSceneImporter->RunImport())
		throw std::exception("Failed to load Chain/Chain.obj.");
	Simplygon::spScene sgScene = sgSceneImporter->GetScene();

	Simplygon::spSceneExporter  sgSceneExporter = sg->CreateSceneExporter();
	sgSceneExporter->SetScene(sgScene);
	sgSceneExporter->SetExportFilePath( "OBJOutput.obj" );
	if(!sgSceneExporter->RunExport())
		throw std::exception("Failed to save OBJOutput.obj.");

}

void main()
{
	Simplygon::ISimplygon* sg = NULL;
	Simplygon::EErrorCodes initval = Simplygon::Initialize( &sg );
	if( initval != Simplygon::EErrorCodes::NoError )
	{
		return;
	}

	ImportExportOBJ(sg);

	Simplygon::Deinitialize(sg);
}

